2016-05-28 07:03:38 +00:00
#!/bin/bash
# Basic integration tests with postgres. Requires docker to work.
2016-11-16 13:58:25 +00:00
SOURCE="${BASH_SOURCE[0]}"
while [ -h "$SOURCE" ]; do # resolve $SOURCE until the file is no longer a symlink
DIR="$( cd -P "$( dirname "$SOURCE" )" && pwd )"
SOURCE="$(readlink "$SOURCE")"
[[ $SOURCE != /* ]] && SOURCE="$DIR/$SOURCE" # if $SOURCE was a relative symlink, we need to resolve it relative to the path where the symlink file was located
done
DIR="$( cd -P "$( dirname "$SOURCE" )" && pwd )"
2016-11-16 15:00:42 +00:00
# Read the absolute path to the exporter
postgres_exporter=$(readlink -f $1)
exporter_port=9187
$exporter_port=password
2016-11-16 13:58:25 +00:00
cd $DIR
2016-05-28 07:03:38 +00:00
VERSIONS=( \
9.1 \
9.2 \
9.3 \
9.4 \
9.5 \
2016-11-16 13:58:25 +00:00
9.6 \
2016-05-28 07:03:38 +00:00
)
smoketest_postgres() {
local version=$1
local CONTAINER_NAME=postgres_exporter-test-smoke
local TIMEOUT=30
local IMAGE_NAME=postgres
local CUR_IMAGE=$IMAGE_NAME:$version
2016-11-16 13:58:25 +00:00
echo "Test standalone cluster..."
2016-11-16 15:00:42 +00:00
CONTAINER_NAME=$(docker run -d -e POSTGRES_PASSWORD=$POSTGRES_PASSWORD -p 127.0.0.1:55432:5432 $CUR_IMAGE)
2016-05-28 07:03:38 +00:00
2016-11-16 15:00:42 +00:00
trap "docker logs $CONTAINER_NAME ; docker kill $CONTAINER_NAME ; docker rm $CONTAINER_NAME; exit 1" EXIT INT TERM
2016-11-16 13:58:25 +00:00
2016-05-28 07:03:38 +00:00
local WAIT_START=$(date +%s)
while ! docker exec $CONTAINER_NAME bash -c "psql -U postgres -c \"select 'running'\" > /dev/null 2>&1 " ; do
echo "Waiting for postgres to start..."
if [ $(( $(date +%s) - $WAIT_START )) -gt $TIMEOUT ]; then
echo "Timed out waiting for postgres!" 1>&2
exit 1
fi
sleep 1
done
2016-11-16 15:00:42 +00:00
DATA_SOURCE_NAME="postgresql://postgres:$POSTGRES_PASSWORD@localhost:55432/?sslmode=disable" $postgres_exporter &
2016-05-28 07:03:38 +00:00
exporter_pid=$!
2016-11-16 15:00:42 +00:00
trap "docker logs $CONTAINER_NAME ; docker kill $CONTAINER_NAME ; docker rm $CONTAINER_NAME ; kill $exporter_pid; exit 1" EXIT INT TERM
2016-05-28 07:03:38 +00:00
local DAEMON_WAIT_START=$(date +%s)
2016-11-16 15:00:42 +00:00
while ! nc -z localhost $exporter_port ; do
2016-05-28 07:03:38 +00:00
echo "Waiting for exporter to start..."
if [ $(( $(date +%s) - $WAIT_START )) -gt $TIMEOUT ]; then
echo "Timed out waiting for exporter!" 1>&2
exit 1
fi
sleep 1
done
2016-11-16 15:00:42 +00:00
wget -q -O - http://localhost:$exporter_port/metrics 1> /dev/null
2016-05-28 07:03:38 +00:00
if [ "$?" != "0" ]; then
echo "Failed on postgres $version ($DOCKER_IMAGE)" 1>&2
kill $exporter_pid
exit 1
fi
kill $exporter_pid
docker kill $CONTAINER_NAME
docker rm $CONTAINER_NAME
2016-11-16 13:58:25 +00:00
trap - EXIT INT TERM
echo "Test replicated cluster..."
old_pwd=$(pwd)
cd docker-postgres-replication
VERSION=$version p2 -t Dockerfile.p2 -o Dockerfile
if [ "$?" != "0" ]; then
echo "Templating failed" 1>&2
exit 1
fi
2016-11-16 15:00:42 +00:00
trap "docker-compose logs; docker-compose down ; docker-compose rm -v; exit 1" EXIT INT TERM
POSTGRES_PASSWORD=$POSTGRES_PASSWORD docker-compose up -d --force-recreate --build
2016-11-16 13:58:25 +00:00
master_container=$(docker-compose ps -q pg-master)
slave_container=$(docker-compose ps -q pg-slave)
master_ip=$(docker inspect -f '{{range .NetworkSettings.Networks}}{{.IPAddress}}{{end}}' $master_container)
local WAIT_START=$(date +%s)
while ! docker exec $master_container bash -c "psql -U postgres -c \"select 'running'\" > /dev/null 2>&1 " ; do
echo "Waiting for postgres master to start..."
if [ $(( $(date +%s) - $WAIT_START )) -gt $TIMEOUT ]; then
echo "Timed out waiting for postgres!" 1>&2
exit 1
fi
sleep 1
done
local WAIT_START=$(date +%s)
while ! docker exec $slave_container bash -c "psql -U postgres -c \"select 'running'\" > /dev/null 2>&1 " ; do
echo "Waiting for postgres master to start..."
if [ $(( $(date +%s) - $WAIT_START )) -gt $TIMEOUT ]; then
echo "Timed out waiting for postgres!" 1>&2
exit 1
fi
sleep 1
done
2016-11-16 15:00:42 +00:00
DATA_SOURCE_NAME="postgresql://postgres:$POSTGRES_PASSWORD@$master_ip:5432/?sslmode=disable" $postgres_exporter &
2016-11-16 13:58:25 +00:00
exporter_pid=$!
2016-11-16 15:00:42 +00:00
trap "docker-compose logs; docker-compose down ; docker-compose rm -v ; kill $exporter_pid; exit 1" EXIT INT TERM
2016-11-16 13:58:25 +00:00
local DAEMON_WAIT_START=$(date +%s)
2016-11-16 15:00:42 +00:00
while ! nc -z localhost $exporter_port ; do
2016-11-16 13:58:25 +00:00
echo "Waiting for exporter to start..."
if [ $(( $(date +%s) - $WAIT_START )) -gt $TIMEOUT ]; then
echo "Timed out waiting for exporter!" 1>&2
exit 1
fi
sleep 1
done
2016-11-16 15:00:42 +00:00
wget -q -O - http://localhost:$exporter_port/metrics 1> /dev/null
2016-11-16 13:58:25 +00:00
if [ "$?" != "0" ]; then
echo "Failed on postgres $version ($DOCKER_IMAGE)" 1>&2
exit 1
fi
kill $exporter_pid
docker-compose down
docker-compose rm -v
trap - EXIT INT TERM
cd $old_pwd
2016-05-28 07:03:38 +00:00
}
# Start pulling the docker images in advance
for version in ${VERSIONS[@]}; do
docker pull postgres:$version > /dev/null &
done
for version in ${VERSIONS[@]}; do
echo "Testing postgres version $version"
smoketest_postgres $version
done